# set version string here
# if run from svn checkout, the svn revision will be picked up instead

__version__ = '1.2'
    
__all__ = ['spec','model','fit']

from os import path, curdir
import sys

from misc import frozen_base, source_base

if hasattr(sys, 'frozen'):
    revpath = path.join(frozen_base, 'SVNREVISION')
else:
    revpath = path.join(source_base, 'SVNREVISION')

def svn_revision():
    ''' tries to determine svn version by reading the .svn/all-wcprops file'''
    svnpath = path.join(path.dirname(__file__),'.svn','all-wcprops')
    if path.exists(svnpath):
        #print 'found svn'
        rev = 0
        for l in open(svnpath):
            if l[0] == '/':
                rev = max(int(l.split('/')[5]), rev)
        return rev
    elif hasattr(sys, "frozen") or path.exists(revpath): 
        try:
            rev = int(open(revpath).read().strip())
        except IOError:
            print 'IOError'
            return None
        else:
            return rev
    return None

rev = svn_revision()
if rev is not None:
    __version__ = '000%d'%rev
